var interval = 60000;
var godirect = 0;
var interval_str = "interval";
var godirect_str = "godirect";

var xml_request = null;

function startWidget()
{
	if(window.widget)
	{
		var val = widget.preferenceForKey(interval_str);
		if(val != '' || val != undefined)
		{
			interval = val;
		}
		val = widget.preferenceForKey(godirect_str);
        if(val != '' || val != undefined)
        {
            godirect = val;
        }
 	}

	var obj = document.getElementById(interval_str);
	for(i = 0; i < obj.length; i++)
	{
		if(obj.options[i].value == interval)
		{	
			obj.selectedIndex = i;
			break;
		}	
	}

	if(godirect == 1)
		document.getElementById(godirect_str).checked = true;
		
	getAllBlogData();	
}

function saveAllBlog()
{
	var obj = document.getElementById(interval_str);

	if(obj.value)
	{
	 	if(window.widget)
		{
			interval = obj.options[obj.selectedIndex].value;
			widget.setPreferenceForKey(interval, interval_str);
			
			if(document.getElementById(godirect_str).checked == true)
				godirect = 1;
			else
				godirect = 0;
			widget.setPreferenceForKey(godirect, godirect_str);
			viewPanel(1);
			getAllBlogData();
		}
	}
}

function viewPanel(idx)
{
	if(idx == 0)
	{
		document.getElementById('content').style.display = 'none';
		document.getElementById('setup').style.display = 'block';
	}
	else
	{
		document.getElementById('content').style.display = 'block';
		document.getElementById('setup').style.display = 'none';
	}
}

function findChild (element, nodeName)
{
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
			return child;
	}
	
	return null;
}

function resultFromAllBlog(e, request)
{
	xml_request = null;
	if(request.responseXML)
	{
		var rss = findChild(request.responseXML, 'rss');
		var channel = findChild(rss, 'channel');
		var st = 0;
		for(var item = channel.firstChild; item != null; item = item.nextSibling)
		{
			if(item.nodeName == 'item') 
			{
				var title = findChild (item, 'title').firstChild.data;
				var link = findChild (item, 'link').firstChild.data;
				var author = findChild (item, 'author').firstChild.data;
	
				var pos = st + 1;

				if(godirect)
				{
					var nn = link.search("/http:");
					link = link.substr(nn+1);
				}
		
				var text = '<div class="box">' + pos + '</div>';
				text += '<div class="c-title"><a href=javascript:widget.openURL("'+link+'")>' + title + '</a></div>';
				text += '<div class="c-author">By '+author+'</div>';		

				document.getElementById('rank'+st).innerHTML = text;
				st++;
			}
		}
	}
}

function getAllBlogData()
{
   	var url = "http://rss.allblog.net/TodayBestPosts.xml";
	if(xml_request != null)
	{
		xml_request.abort();
		xml_request = null;
	}	

	xml_request = new XMLHttpRequest();
    if(xml_request == null)
       	return;

	xml_request.onload = function(e) {resultFromAllBlog(e, xml_request);}	
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET", url);
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.send(null);
	
	setTimeout("getAllBlogData()", interval);
}

